/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the MutableTaskData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MutableTaskData{}

// MutableTaskData struct for MutableTaskData
type MutableTaskData struct {
	Text *string `json:"text,omitempty"`
	Type *string `json:"type,omitempty"`
	ContextMap map[string]interface{} `json:"context_map,omitempty"`
	Title *string `json:"title,omitempty"`
	Blocker *bool `json:"blocker,omitempty"`
	DestinationLink *string `json:"destination_link,omitempty"`
	Action *string `json:"action,omitempty"`
	Usages []string `json:"usages,omitempty"`
	Element *MutableTaskDataElement `json:"element,omitempty"`
	ScriptId *string `json:"script_id,omitempty"`
}

// NewMutableTaskData instantiates a new MutableTaskData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMutableTaskData() *MutableTaskData {
	this := MutableTaskData{}
	return &this
}

// NewMutableTaskDataWithDefaults instantiates a new MutableTaskData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMutableTaskDataWithDefaults() *MutableTaskData {
	this := MutableTaskData{}
	return &this
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *MutableTaskData) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *MutableTaskData) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *MutableTaskData) SetText(v string) {
	o.Text = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *MutableTaskData) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *MutableTaskData) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *MutableTaskData) SetType(v string) {
	o.Type = &v
}

// GetContextMap returns the ContextMap field value if set, zero value otherwise.
func (o *MutableTaskData) GetContextMap() map[string]interface{} {
	if o == nil || IsNil(o.ContextMap) {
		var ret map[string]interface{}
		return ret
	}
	return o.ContextMap
}

// GetContextMapOk returns a tuple with the ContextMap field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetContextMapOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ContextMap) {
		return map[string]interface{}{}, false
	}
	return o.ContextMap, true
}

// HasContextMap returns a boolean if a field has been set.
func (o *MutableTaskData) HasContextMap() bool {
	if o != nil && !IsNil(o.ContextMap) {
		return true
	}

	return false
}

// SetContextMap gets a reference to the given map[string]interface{} and assigns it to the ContextMap field.
func (o *MutableTaskData) SetContextMap(v map[string]interface{}) {
	o.ContextMap = v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *MutableTaskData) GetTitle() string {
	if o == nil || IsNil(o.Title) {
		var ret string
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetTitleOk() (*string, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *MutableTaskData) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given string and assigns it to the Title field.
func (o *MutableTaskData) SetTitle(v string) {
	o.Title = &v
}

// GetBlocker returns the Blocker field value if set, zero value otherwise.
func (o *MutableTaskData) GetBlocker() bool {
	if o == nil || IsNil(o.Blocker) {
		var ret bool
		return ret
	}
	return *o.Blocker
}

// GetBlockerOk returns a tuple with the Blocker field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetBlockerOk() (*bool, bool) {
	if o == nil || IsNil(o.Blocker) {
		return nil, false
	}
	return o.Blocker, true
}

// HasBlocker returns a boolean if a field has been set.
func (o *MutableTaskData) HasBlocker() bool {
	if o != nil && !IsNil(o.Blocker) {
		return true
	}

	return false
}

// SetBlocker gets a reference to the given bool and assigns it to the Blocker field.
func (o *MutableTaskData) SetBlocker(v bool) {
	o.Blocker = &v
}

// GetDestinationLink returns the DestinationLink field value if set, zero value otherwise.
func (o *MutableTaskData) GetDestinationLink() string {
	if o == nil || IsNil(o.DestinationLink) {
		var ret string
		return ret
	}
	return *o.DestinationLink
}

// GetDestinationLinkOk returns a tuple with the DestinationLink field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetDestinationLinkOk() (*string, bool) {
	if o == nil || IsNil(o.DestinationLink) {
		return nil, false
	}
	return o.DestinationLink, true
}

// HasDestinationLink returns a boolean if a field has been set.
func (o *MutableTaskData) HasDestinationLink() bool {
	if o != nil && !IsNil(o.DestinationLink) {
		return true
	}

	return false
}

// SetDestinationLink gets a reference to the given string and assigns it to the DestinationLink field.
func (o *MutableTaskData) SetDestinationLink(v string) {
	o.DestinationLink = &v
}

// GetAction returns the Action field value if set, zero value otherwise.
func (o *MutableTaskData) GetAction() string {
	if o == nil || IsNil(o.Action) {
		var ret string
		return ret
	}
	return *o.Action
}

// GetActionOk returns a tuple with the Action field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetActionOk() (*string, bool) {
	if o == nil || IsNil(o.Action) {
		return nil, false
	}
	return o.Action, true
}

// HasAction returns a boolean if a field has been set.
func (o *MutableTaskData) HasAction() bool {
	if o != nil && !IsNil(o.Action) {
		return true
	}

	return false
}

// SetAction gets a reference to the given string and assigns it to the Action field.
func (o *MutableTaskData) SetAction(v string) {
	o.Action = &v
}

// GetUsages returns the Usages field value if set, zero value otherwise.
func (o *MutableTaskData) GetUsages() []string {
	if o == nil || IsNil(o.Usages) {
		var ret []string
		return ret
	}
	return o.Usages
}

// GetUsagesOk returns a tuple with the Usages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetUsagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Usages) {
		return nil, false
	}
	return o.Usages, true
}

// HasUsages returns a boolean if a field has been set.
func (o *MutableTaskData) HasUsages() bool {
	if o != nil && !IsNil(o.Usages) {
		return true
	}

	return false
}

// SetUsages gets a reference to the given []string and assigns it to the Usages field.
func (o *MutableTaskData) SetUsages(v []string) {
	o.Usages = v
}

// GetElement returns the Element field value if set, zero value otherwise.
func (o *MutableTaskData) GetElement() MutableTaskDataElement {
	if o == nil || IsNil(o.Element) {
		var ret MutableTaskDataElement
		return ret
	}
	return *o.Element
}

// GetElementOk returns a tuple with the Element field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetElementOk() (*MutableTaskDataElement, bool) {
	if o == nil || IsNil(o.Element) {
		return nil, false
	}
	return o.Element, true
}

// HasElement returns a boolean if a field has been set.
func (o *MutableTaskData) HasElement() bool {
	if o != nil && !IsNil(o.Element) {
		return true
	}

	return false
}

// SetElement gets a reference to the given MutableTaskDataElement and assigns it to the Element field.
func (o *MutableTaskData) SetElement(v MutableTaskDataElement) {
	o.Element = &v
}

// GetScriptId returns the ScriptId field value if set, zero value otherwise.
func (o *MutableTaskData) GetScriptId() string {
	if o == nil || IsNil(o.ScriptId) {
		var ret string
		return ret
	}
	return *o.ScriptId
}

// GetScriptIdOk returns a tuple with the ScriptId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MutableTaskData) GetScriptIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScriptId) {
		return nil, false
	}
	return o.ScriptId, true
}

// HasScriptId returns a boolean if a field has been set.
func (o *MutableTaskData) HasScriptId() bool {
	if o != nil && !IsNil(o.ScriptId) {
		return true
	}

	return false
}

// SetScriptId gets a reference to the given string and assigns it to the ScriptId field.
func (o *MutableTaskData) SetScriptId(v string) {
	o.ScriptId = &v
}

func (o MutableTaskData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MutableTaskData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.ContextMap) {
		toSerialize["context_map"] = o.ContextMap
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	if !IsNil(o.Blocker) {
		toSerialize["blocker"] = o.Blocker
	}
	if !IsNil(o.DestinationLink) {
		toSerialize["destination_link"] = o.DestinationLink
	}
	if !IsNil(o.Action) {
		toSerialize["action"] = o.Action
	}
	if !IsNil(o.Usages) {
		toSerialize["usages"] = o.Usages
	}
	if !IsNil(o.Element) {
		toSerialize["element"] = o.Element
	}
	if !IsNil(o.ScriptId) {
		toSerialize["script_id"] = o.ScriptId
	}
	return toSerialize, nil
}

type NullableMutableTaskData struct {
	value *MutableTaskData
	isSet bool
}

func (v NullableMutableTaskData) Get() *MutableTaskData {
	return v.value
}

func (v *NullableMutableTaskData) Set(val *MutableTaskData) {
	v.value = val
	v.isSet = true
}

func (v NullableMutableTaskData) IsSet() bool {
	return v.isSet
}

func (v *NullableMutableTaskData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMutableTaskData(val *MutableTaskData) *NullableMutableTaskData {
	return &NullableMutableTaskData{value: val, isSet: true}
}

func (v NullableMutableTaskData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMutableTaskData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


